/**
 * @(#)Tokens.java 1.01 26/07/2006
 * Copyright 2005 usd.sie.dendai.ac.jp, All rights reserved.
 */
package jp.tdu.util;

import java.util.Iterator;
import java.lang.Iterable;
import java.util.List;
import java.util.ArrayList;
import java.util.Collections;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

/**
 * iQjAf~b^[i؂蕶jŋ؂ꂽ
 * ǗNXłB̗vfint^Along^邢double^֕ϊ
 * 邱Ƃł܂B
 * @version 1.01, 25/01/2011
 * @author miya@sie.dendai.ac.jp
 */
public class Tokens implements Iterable<String>{
	private static final String delim = " \t";
	private static final String quoteChars = "\'\"";
	private static final Class<?>[] types = {String.class};
	private ArrayList<String> list = new ArrayList<String>();
	private String string;
	
	/**
	 * p[^ƂĕiQj󂯎RXgN^B
	 * Ap[^Ƃăf~b^[Apȗꍇɂ́A
	 * f~b^[" \t"ŋ󔒕ƃ^uAp"\'\""ŃVOE_uquote\܂B
	 * ̈pň͂܂ꂽ͂ꍇA؂蕶gĂȂpƂĔF܂A
	 * ͂߂Ɏgp̈p͍폜܂B܂Äpň͂܂ꂽ̒ɁA
	 * ̈p𕶎Ƃē͂ɂ́Äp2dɋLq܂B
	 * @param string iSjB
	 */
	public Tokens(String string){
		this(string, Tokens.delim, Tokens.quoteChars);
	}
	
	/**
	 * p[^ƂĕiQjƃf~b^[i؂蕶j󂯎RXgN^B
	 * @param string iSjB
	 * @param delim f~b^[i؂蕶jB
	 */
	public Tokens(String string, String delim){
		this(string, delim, Tokens.quoteChars);
	}
	
	/**
	 * p[^ƂĕiQjAf~b^[i؂蕶jƈp󂯎RXgN^B
	 * @param string iSjB
	 * @param delim f~b^[i؂蕶jB
	 * @param quoteChars pB
	 */
	public Tokens(String string, String delim, String quoteChars){
		if(delim == null){
			delim = Tokens.delim;
		}
		if(quoteChars == null){
			quoteChars = Tokens.quoteChars;
		}
		if(string != null){
			this.string = string;
			int current = this.skipInit(0, string, delim);
			int max = string.length();
			while(current < max){
				int start = current;
				if(quoteChars.indexOf(string.charAt(start)) < 0){
					while((current < max) && (delim.indexOf(string.charAt(current)) < 0)){
						current++;
					}
					this.list.add(string.substring(start, current));
				}else{
					current++;
					StringBuffer sb = new StringBuffer();
					if(start + 1 < max){
						while((current < max) && ((string.charAt(current) != string.charAt(start)) || (current + 1 < max ? string.charAt(current + 1) == string.charAt(start): false))){
							if(string.charAt(current) != string.charAt(start)){
								sb.append(string.charAt(current));
							}else{
								sb.append(string.charAt(++current));
							}
							current++;
						}
						this.list.add(sb.toString());
						current++;
					}
				}
				current = this.skipDelim(current, string, delim);
			}
		}
	}
	int skipDelim(int current, String string, String delim){
		while((current < string.length()) && (delim.indexOf(string.charAt(current)) >= 0)){
			current++;
		}
		return current;
	}
	int skipInit(int current, String string, String delim){
		return this.skipDelim(current, string, delim);
	}
	
	/**
	 * w肳ꂽʒu̕int^ɕϊ܂B
	 * Aint^ɕϊłȂꍇInteger.MAX_VALUEԋp܂B
	 * @param number ԁB
	 * @return w肵Ԃ̒lB
	 */
	public int getInt(int number){
		if(this.list.size() > number){
			try{
				return Integer.parseInt(this.list.get(number));
			}catch(NumberFormatException e){
			}
		}
		return Integer.MAX_VALUE;
	}
	
	/**
	 * w肳ꂽʒu̕long^ɕϊ܂B
	 * Alogn^ɕϊłȂꍇLong.MAX_VALUEԋp܂B
	 * @param number ԁB
	 * @return w肵Ԃ̒lB
	 */
	public long getLong(int number){
		if(this.list.size() > number){
			try{
				return Long.parseLong(this.list.get(number));
			}catch(NumberFormatException e){
			}
		}
		return Long.MAX_VALUE;
	}
	
	/**
	 * w肳ꂽʒu̕ԋp܂B
	 * @param number ԁB
	 * @return w肵Ԃ̕B
	 */
	public String getString(int number){
		if(this.list.size() > number){
			return this.list.get(number);
		}
		return null;
	}
	
	/**
	 * RXgN^ŗ^ꂽiSjB
	 * @return iSjB
	 */
	public String toString(){
		return this.string;
	}
	
	/**
	 * w肳ꂽʒu̕double^ɕϊ܂B
	 * Adouble^ɕϊłȂꍇDouble.MAX_VALUEԋp܂B
	 * @param number ԁB
	 * @return w肵Ԃ̒lB
	 */
	public double getDouble(int number){
		if(this.list.size() > number){
			try{
				return new Double(this.list.get(number)).doubleValue();
			}catch(NumberFormatException e){
			}
		}
		return Double.MAX_VALUE;
	}
	
	/**
	 * iSjɂvf̌ԋp܂B
	 * @return iSjɂvf̌B
	 */
	public int size(){
		return this.list.size();
	}
	
	/**
	 * ̕iSj̗vfK؂ȏŌJԂ锽qԋp܂B 
	 * @return iSj̗vfK؂ȏŌJԂ锽qB
	 */
	public Iterator<String> iterator(){
		return Collections.unmodifiableList(this.list).iterator();
	}
	
	/**
	 * iSjClassNXŎw肵^ɕϊAvfƂ郊Xgԋp܂B
	 * @param clazz vf̕ϊ^B
	 * @return iSji[VXgB
	 */
	public <T extends Number> List<T> createList(Class<T> clazz) throws 
			InstantiationException, NoSuchMethodException, IllegalAccessException, InvocationTargetException{
		ArrayList<T> arrayList = new ArrayList<T>(this.list.size());
		Constructor<T> constructor = clazz.getConstructor(Tokens.types);
		for(String s: this.list){
			arrayList.add(constructor.newInstance(s));
		}
		return arrayList;
	}
	
	/**
	 * ̕iSji[Xgԋp܂B
	 * @return iSji[XgB
	 */
	public List<String> getList(){
		return Collections.unmodifiableList(this.list);
	}
	
	/**
	 * CSV`if[^tH[}bg`̈jŃtH[}bgꂽiSj
	 * 󂯎TokensCX^X𐶐܂B
	 * @param string iSjB
	 * @return CSV`pTokensCX^XB
	 */
	public static Tokens getCSVInstance(String string){
		char d = ',';
		String delim = new String(new char[]{d});
		Tokens tokens = new Tokens(string, delim){
			int skipDelim(int current, String string, String delim){
				return ++current;
			}
			int skipInit(int current, String string, String delim){
				return 0;
			}
		};
		if(tokens.toString().charAt(tokens.toString().length() - 1) == d){
			tokens.list.add("");
		}
		return tokens;
	}
	
	/**
	 * TokensCX^X󂯎ACSV`if[^tH[}bg`̈jŃtH[}bgꂽiSj
	 * ϊ܂B
	 * @param CSV`pTokensCX^XB
	 * @return string iSjB
	 */
	public static String toCSV(Tokens tokens){
		char quoteChar = '"';
		if(tokens.size() == 0){
			return "";
		}
		StringBuffer sb = new StringBuffer();
		sb.append(Tokens.convert(tokens.getString(0), quoteChar));
		for(int i = 0; i < tokens.size(); i++){
			sb.append(',');
			sb.append(Tokens.convert(tokens.getString(i), quoteChar));
		}
		return sb.toString();
	}
	
	public static String convert(String string, char quoteChar){
		try{
			new Double(string).doubleValue();
			return string;
		}catch(NumberFormatException e){
		}
		int current = 0;
		StringBuffer sb = new StringBuffer();
		if(string.indexOf(quoteChar) < 0){
			return string;
		}
		sb.append(quoteChar);
		while(current < string.length()){
			int start = current;
			current = string.indexOf(quoteChar, start);
			if(current < 0){
				sb.append(string.substring(start, string.length()));
				sb.append(quoteChar);
				return sb.toString();
			} else {
				sb.append(string.substring(start, current));
				sb.append(quoteChar);
				sb.append(quoteChar);
				current++;
			}
		}
		return "";
	}
	
}
